/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.demo.mysqldao;

import io.github.cdimascio.dotenv.Dotenv;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import so.demo.dao.DAOFactory;
import so.demo.dao.UbigeoDAO;
import so.demo.utilities.OsUtils;

/**
 *
 * @author Felipe Escala
 */
public class MySqlDAOFactory extends DAOFactory {

	static {
		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	public static Connection obtenerConexion(String base) {
		Dotenv dotenv = Dotenv
			.configure()
			.directory(OsUtils.getDotEnvPath())
			.load();
		Connection connection = null;
		String host = dotenv.get("MYSQL_DB_HOST");
		String port = dotenv.get("MYSQL_DB_PORT");
		String databaseName = dotenv.get("MYSQL_DB_NAME");
		String userSgbd = dotenv.get("MYSQL_DB_USER");
		String passwordSgbd = dotenv.get("MYSQL_DB_PASS");

		if (base.equals("nuevo")) {
			try {
				connection = DriverManager.getConnection(
					"jdbc:mysql://" + host + ":" + port + "/" + databaseName + "?useUnicode=true&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC&useSSL=false",
					userSgbd,
					passwordSgbd);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return connection;
	}

	@Override
	public UbigeoDAO getUbigeoDAO() {
		return new UbigeoMysqlDAO();
	}
	
	public static void main(String[] args) {
		MySqlDAOFactory da=new MySqlDAOFactory();
		da.obtenerConexion("nuevo");
	}
}
