/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.demo.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import org.json.JSONArray;
import org.json.JSONObject;
import so.demo.dao.UbigeoDAO;
import so.demo.utilities.ResponseHelper;

/**
 *
 * @author Felipe Escala
 */
public class UbigeoMysqlDAO implements UbigeoDAO {

	@Override
	public JSONObject listarDepartamento(JSONObject obj) {
		JSONObject retorno;
		ResponseHelper response = new ResponseHelper();
		JSONArray lista = new JSONArray();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rs = null;
		String sql = "";
		try {
			con = MySqlDAOFactory.obtenerConexion("nuevo");
			sql = " select codigo_departamento, nombre_departamento from ubigeo \n"
				+ "GROUP BY codigo_departamento ";
			pst = con.prepareStatement(sql);
			rs = pst.executeQuery();
			while (rs.next()) {
				JSONObject a = new JSONObject();
				a.put("codigoDepartamento", rs.getInt(1));
				a.put("nombreDepartamento", rs.getString(2));
				lista.put(a);
			}
			response.setStatus(lista.length() > 0);
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error ---> " + e.getMessage());
		} finally {
			try {
				if (con != null) {
					con.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (rs != null) {
					rs.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error ---> " + e.getMessage());
			}
		}
		retorno = new JSONObject(response);
		return retorno;
	}

	@Override
	public JSONObject listarProvincia(JSONObject obj) throws Exception {
		JSONObject retorno;
		ResponseHelper response = new ResponseHelper();
		JSONArray lista = new JSONArray();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rs = null;
		String sql = "";
		try {
			con = MySqlDAOFactory.obtenerConexion("nuevo");
			sql = " SELECT "
				+ "	codigo_provincia, "
				+ "	nombre_provincia "
				+ "FROM "
				+ "	ubigeo "
				+ "WHERE "
				+ "	codigo_departamento =? "
				+ "GROUP BY "
				+ "	codigo_provincia ";
			pst = con.prepareStatement(sql);
			pst.setInt(1, obj.getInt("codigoDepartamento"));
			rs = pst.executeQuery();
			while (rs.next()) {
				JSONObject a = new JSONObject();
				a.put("codigo_provincia", rs.getInt(1));
				a.put("nombre_provincia", rs.getString(2));
				lista.put(a);
			}
			response.setStatus(lista.length() > 0);
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error ---> " + e.getMessage());
		} finally {
			try {
				if (con != null) {
					con.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (rs != null) {
					rs.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error ---> " + e.getMessage());
			}
		}
		retorno = new JSONObject(response);
		return retorno;
	}

	@Override
	public JSONObject listarDistrito(JSONObject obj) throws Exception {
		JSONObject retorno;
		ResponseHelper response = new ResponseHelper();
		JSONArray lista = new JSONArray();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rs = null;
		String sql = "";
		try {
			con = MySqlDAOFactory.obtenerConexion("nuevo");
			sql = " SELECT "
				+ "	codigo_distrito, "
				+ "	nombre_distrito "
				+ "FROM "
				+ "	ubigeo "
				+ "WHERE "
				+ "	codigo_provincia = ? "
				+ "AND codigo_departamento = ? ";
			pst = con.prepareStatement(sql);
			pst.setInt(1, obj.getInt("codigoProvincia"));
			pst.setInt(2, obj.getInt("codigoDepartamento"));
			rs = pst.executeQuery();
			while (rs.next()) {
				JSONObject a = new JSONObject();
				a.put("codigo_distrito", rs.getInt(1));
				a.put("nombre_distrito", rs.getString(2));
				lista.put(a);
			}
			response.setStatus(lista.length() > 0);
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error ---> " + e.getMessage());
		} finally {
			try {
				if (con != null) {
					con.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (rs != null) {
					rs.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error ---> " + e.getMessage());
			}
		}
		retorno = new JSONObject(response);
		return retorno;

	}

	@Override
	public JSONObject listarAlumno(JSONObject obj) throws Exception {
		JSONObject jreturn = new JSONObject();
		JSONArray lista = new JSONArray();
		Connection cn = null;
		PreparedStatement pst = null;
		ResultSet rs = null;
		int cantidadRegistros = 0;
		String sql;
		String filtros = "";
		try {
			if (obj.has("nombreEstudiante")) {
				filtros = " where nom_alu like ? ";
			}
			cn = MySqlDAOFactory.obtenerConexion("nuevo");
			sql = "select id_alu,nom_alu,ape_alu from alumno " + filtros + " limit ?,?";
			pst = cn.prepareStatement(sql);
			int c = 1;
			if (obj.has("nombreEstudiante")) {
				pst.setString(c++, "%" + obj.getString("nombreEstudiante") + "%"
				);
			}
			pst.setInt(c++, obj.getInt("start"));
			pst.setInt(c++, obj.getInt("length"));
			System.out.println("Query --> " + pst);
			rs = pst.executeQuery();
			int contador = obj.getInt("start") + 1; // SE SUMA 1 YA QUE POR DEFECTO INICIA EN 0

			while (rs.next()) {
				JSONObject jsonObj = new JSONObject();
				jsonObj.put("numeral", contador++);
				jsonObj.put("codialumno", rs.getInt(1));
				jsonObj.put("nombrealumno", rs.getString(2));
				jsonObj.put("apellidoalumno", rs.getString(3));
				lista.put(jsonObj);
			}
			//QUERY PARA OBTENER LA CANTIDAD DE REGISTROS QUE HAY EN LA TABLA ALUMNOS
			sql = "select COUNT(*) from alumno";
			pst = cn.prepareStatement(sql);
			rs = pst.executeQuery();
			rs.next();
			cantidadRegistros = rs.getInt(1);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {

				if (rs != null) {
					rs.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (cn != null) {
					cn.close();
				}

			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		jreturn.put("data", lista);
		jreturn.put("recordsFiltered", cantidadRegistros);
		jreturn.put("recordsTotal", cantidadRegistros);
		jreturn.put("draw", obj.getInt("draw"));

		return jreturn;

	}

	@Override
	public JSONObject eliminarAlumno(JSONObject obj) throws Exception {
		throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
	}

}
